## nmodl 0.5

=== src/CMakeLists.txt ===
# =============================================================================
# Add extra compile flags to NMODL sources
# =============================================================================
add_compile_options(${NMODL_EXTRA_CXX_FLAGS})
add_link_options(${NMODL_EXTRA_CXX_FLAGS})

add_subdirectory(codegen)
add_subdirectory(language)
add_subdirectory(lexer)
add_subdirectory(parser)
add_subdirectory(printer)
add_subdirectory(symtab)
add_subdirectory(utils)
add_subdirectory(visitors)
add_subdirectory(pybind)
add_subdirectory(solver)

# =============================================================================
# NMODL sources
# =============================================================================
include_directories(${PYBIND11_INCLUDE_DIR} ${PYTHON_INCLUDE_DIRS})

# =============================================================================
# Add executables
# =============================================================================
add_executable(nmodl main.cpp)
target_link_libraries(
  nmodl
  CLI11::CLI11
  printer
  codegen
  visitor
  symtab
  util
  lexer
  ${NMODL_WRAPPER_LIBS})
cpp_cc_configure_sanitizers(TARGET nmodl)

# =============================================================================
# Add dependency with nmodl pytnon module (for consumer projects)
# =============================================================================
add_dependencies(nmodl pywrapper)

if(NMODL_ENABLE_PYTHON_BINDINGS)
  add_dependencies(nmodl _nmodl)
endif()

# =============================================================================
# Install executable
# =============================================================================
install(TARGETS nmodl DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}bin)
install(FILES nmodl.hpp DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}include)

=== src/language/CMakeLists.txt ===
# =============================================================================
# Command to generate AST/Visitor classes from language definition
# =============================================================================
set_source_files_properties(${NMODL_GENERATED_SOURCES} PROPERTIES GENERATED TRUE)

# clang-format is handled by the HPC coding conventions scripts, which also handle generating the
# .clang-format configuration file. It's important that we only try to format code if formatting was
# enabled and NMODL's .clang-format exists, otherwise clang-format will search too far up the
# directory tree and find the wrong configuration file. This can break compilation.
if(NMODL_CLANG_FORMAT OR NMODL_FORMATTING)
  set(CODE_GENERATOR_OPTS -v --clang-format=${ClangFormat_EXECUTABLE})
  foreach(clang_format_opt ${NMODL_ClangFormat_OPTIONS} --style=file)
    list(APPEND CODE_GENERATOR_OPTS --clang-format-opts=${clang_format_opt})
  endforeach()
endif()

add_custom_command(
  OUTPUT ${NMODL_GENERATED_SOURCES}
  COMMAND ${PYTHON_EXECUTABLE} ARGS ${CMAKE_CURRENT_SOURCE_DIR}/code_generator.py
          ${CODE_GENERATOR_OPTS} --base-dir ${PROJECT_BINARY_DIR}/src
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${CODE_GENERATOR_PY_FILES}
  DEPENDS ${CODE_GENERATOR_YAML_FILES}
  DEPENDS ${CODE_GENERATOR_JINJA_FILES}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/templates/code_generator.cmake
  COMMENT "-- NMODL : GENERATING AST CLASSES WITH PYTHON GENERATOR! --")
unset(CODE_GENERATOR_OPTS)

# =============================================================================
# Target to propagate dependencies properly to lexer
# =============================================================================
add_custom_target(pyastgen DEPENDS ${PROJECT_BINARY_DIR}/src/ast/ast.cpp)

=== src/lexer/CMakeLists.txt ===
# =============================================================================
# Various project components and their source files
# =============================================================================
set(BISON_GENERATED_SOURCE_FILES
    ${PROJECT_BINARY_DIR}/src/parser/nmodl/nmodl_parser.cpp
    ${PROJECT_BINARY_DIR}/src/parser/verbatim_parser.cpp
    ${PROJECT_BINARY_DIR}/src/parser/diffeq/diffeq_parser.cpp
    ${PROJECT_BINARY_DIR}/src/parser/c/c11_parser.cpp
    ${PROJECT_BINARY_DIR}/src/parser/unit/unit_parser.cpp)
set(BISON_GENERATED_HEADER_FILES
    ${PROJECT_BINARY_DIR}/src/parser/nmodl/location.hh
    ${PROJECT_BINARY_DIR}/src/parser/nmodl/nmodl_parser.hpp
    ${PROJECT_BINARY_DIR}/src/parser/nmodl/position.hh
    ${PROJECT_BINARY_DIR}/src/parser/verbatim_parser.hpp
    ${PROJECT_BINARY_DIR}/src/parser/diffeq/diffeq_parser.hpp
    ${PROJECT_BINARY_DIR}/src/parser/c/c11_parser.hpp
    ${PROJECT_BINARY_DIR}/src/parser/unit/unit_parser.hpp)

set(UNIT_SOURCE_FILES ${NMODL_PROJECT_SOURCE_DIR}/src/units/units.cpp)

set(NMODL_DRIVER_FILES ${NMODL_PROJECT_SOURCE_DIR}/src/parser/nmodl_driver.cpp)

set(DIFFEQ_DRIVER_FILES ${NMODL_PROJECT_SOURCE_DIR}/src/parser/diffeq_driver.cpp
                        ${NMODL_PROJECT_SOURCE_DIR}/src/parser/diffeq_context.cpp)

set(C_DRIVER_FILES ${NMODL_PROJECT_SOURCE_DIR}/src/parser/c11_driver.cpp)

set_source_files_properties(${AST_GENERATED_SOURCES} PROPERTIES GENERATED TRUE)

set(UNIT_DRIVER_FILES ${NMODL_PROJECT_SOURCE_DIR}/src/parser/unit_driver.cpp)

set(LEXER_SOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/token_mapping.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/nmodl_utils.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/modtoken.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/nmodl_base_lexer.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/verbatim_lexer.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/diffeq_base_lexer.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/c11_base_lexer.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/unit_base_lexer.cpp
    ${NMODL_DRIVER_FILES}
    ${DIFFEQ_DRIVER_FILES}
    ${C_DRIVER_FILES}
    ${UNIT_DRIVER_FILES})

if(NMODL_PGI_COMPILER)
  # "verbatim_lexer.cpp", warning #550-D: variable "..." was set but never used
  set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/verbatim_lexer.cpp
                              PROPERTIES COMPILE_FLAGS "--diag_suppress 550")
endif()

# =============================================================================
# Directories for parsers (as they need to be in separate directories)
# =============================================================================
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/src/parser/nmodl ${PROJECT_BINARY_DIR}/src/parser/diffeq
     ${PROJECT_BINARY_DIR}/src/parser/c ${PROJECT_BINARY_DIR}/src/parser/unit)

# =============================================================================
# Lexer & Parser commands
# =============================================================================
# Command to generate nmodl parser Construct a relative path to avoid baking any absolute paths into
# the output .cpp and .hpp files (via __FILE__ and so on), which cause ccache misses when the build
# prefix changes (e.g. GitLab CI).
set(NMODL_PARSER_SOURCE_DIR "${NMODL_PROJECT_SOURCE_DIR}/src/parser")
set(NMODL_PARSER_BINARY_DIR "${NMODL_PROJECT_BINARY_DIR}/src/parser")
file(RELATIVE_PATH NMODL_YY_FROM_PARSER_BINARY_DIR "${NMODL_PARSER_BINARY_DIR}"
     "${NMODL_PARSER_SOURCE_DIR}/nmodl.yy")
add_custom_command(
  OUTPUT "${NMODL_PARSER_BINARY_DIR}/nmodl/location.hh"
         "${NMODL_PARSER_BINARY_DIR}/nmodl/nmodl_parser.cpp"
         "${NMODL_PARSER_BINARY_DIR}/nmodl/nmodl_parser.hpp"
         "${NMODL_PARSER_BINARY_DIR}/nmodl/position.hh"
         "${NMODL_PARSER_BINARY_DIR}/nmodl/stack.hh"
  WORKING_DIRECTORY "${NMODL_PARSER_BINARY_DIR}"
  COMMAND ${BISON_EXECUTABLE} ARGS -d -o nmodl/nmodl_parser.cpp "${NMODL_YY_FROM_PARSER_BINARY_DIR}"
  DEPENDS "${NMODL_PARSER_SOURCE_DIR}/nmodl.yy" pyastgen
  COMMENT "-- NMODL : GENERATING NMODL_CORE PARSER WITH BISON! --")

# Command to generate verbatim parser. See comment above about absolute paths.
file(RELATIVE_PATH VERBATIM_YY_FROM_PARSER_BINARY_DIR "${NMODL_PARSER_BINARY_DIR}"
     "${NMODL_PARSER_SOURCE_DIR}/verbatim.yy")
add_custom_command(
  OUTPUT "${NMODL_PARSER_BINARY_DIR}/verbatim_parser.cpp"
         "${NMODL_PARSER_BINARY_DIR}/verbatim_parser.hpp"
  WORKING_DIRECTORY "${NMODL_PARSER_BINARY_DIR}"
  COMMAND ${BISON_EXECUTABLE} ARGS -d -o verbatim_parser.cpp "${VERBATIM_YY_FROM_PARSER_BINARY_DIR}"
  DEPENDS "${NMODL_PARSER_SOURCE_DIR}/verbatim.yy"
  COMMENT "-- NMODL : GENERATING VERBATIM PARSER WITH BISON! --")

# Command to generate differential equation parser. See comment above about absolute paths.
file(RELATIVE_PATH DIFFEQ_YY_FROM_PARSER_BINARY_DIR "${NMODL_PARSER_BINARY_DIR}"
     "${NMODL_PARSER_SOURCE_DIR}/diffeq.yy")
add_custom_command(
  OUTPUT "${NMODL_PARSER_BINARY_DIR}/diffeq/diffeq_parser.cpp"
         "${NMODL_PARSER_BINARY_DIR}/diffeq/diffeq_parser.hpp"
         "${NMODL_PARSER_BINARY_DIR}/diffeq/stack.hh"
  WORKING_DIRECTORY "${NMODL_PARSER_BINARY_DIR}"
  COMMAND ${BISON_EXECUTABLE} ARGS -d -o diffeq/diffeq_parser.cpp
          "${DIFFEQ_YY_FROM_PARSER_BINARY_DIR}"
  DEPENDS "${NMODL_PARSER_SOURCE_DIR}/diffeq.yy" "${NMODL_PARSER_SOURCE_DIR}/diffeq_context.hpp"
          "${NMODL_PARSER_SOURCE_DIR}/diffeq_context.cpp"
          "${NMODL_PARSER_SOURCE_DIR}/diffeq_helper.hpp"
  COMMENT "-- NMODL : GENERATING DIFFERENTIAL EQUATION PARSER WITH BISON! --")

# Command to generate C (11) parser. See comment above about absolute paths.
file(RELATIVE_PATH C11_YY_FROM_PARSER_BINARY_DIR "${NMODL_PARSER_BINARY_DIR}"
     "${NMODL_PARSER_SOURCE_DIR}/c11.yy")
add_custom_command(
  OUTPUT "${NMODL_PARSER_BINARY_DIR}/c/c11_parser.cpp" "${NMODL_PARSER_BINARY_DIR}/c/c11_parser.hpp"
         "${NMODL_PARSER_BINARY_DIR}/c/stack.hh"
  WORKING_DIRECTORY "${NMODL_PARSER_BINARY_DIR}"
  COMMAND ${BISON_EXECUTABLE} ARGS -d -o c/c11_parser.cpp "${C11_YY_FROM_PARSER_BINARY_DIR}"
  DEPENDS "${NMODL_PARSER_SOURCE_DIR}/c11.yy"
  COMMENT "-- NMODL : GENERATING C (11) PARSER WITH BISON! --")

# Command to generate Units parser. See comment above about absolute paths.
file(RELATIVE_PATH UNIT_YY_FROM_PARSER_BINARY_DIR "${NMODL_PARSER_BINARY_DIR}"
     "${NMODL_PARSER_SOURCE_DIR}/unit.yy")
add_custom_command(
  OUTPUT "${NMODL_PARSER_BINARY_DIR}/unit/unit_parser.cpp"
         "${NMODL_PARSER_BINARY_DIR}/unit/unit_parser.hpp"
         "${NMODL_PARSER_BINARY_DIR}/unit/stack.hh"
  WORKING_DIRECTORY "${NMODL_PARSER_BINARY_DIR}"
  COMMAND ${BISON_EXECUTABLE} ARGS -d -o unit/unit_parser.cpp "${UNIT_YY_FROM_PARSER_BINARY_DIR}"
  DEPENDS "${NMODL_PARSER_SOURCE_DIR}/unit.yy"
  COMMENT "-- NMODL : GENERATING UNIT PARSER WITH BISON! --")

# Command to generate nmodl lexer. See comment above about absolute paths.
file(RELATIVE_PATH NMODL_LL_FROM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}"
     "${CMAKE_CURRENT_SOURCE_DIR}/nmodl.ll")
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/nmodl_base_lexer.cpp
         ${CMAKE_CURRENT_BINARY_DIR}/nmodl_base_lexer.hpp
  COMMAND ${FLEX_EXECUTABLE} ARGS "${NMODL_LL_FROM_BINARY_DIR}"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/nmodl.ll ${CMAKE_CURRENT_SOURCE_DIR}/nmodl_utils.hpp
  COMMENT "-- NMODL : GENERATING NMODL LEXER WITH FLEX! --")

# Command to generate verbatim lexer. See comment above about absolute paths.
file(RELATIVE_PATH VERBATIM_LL_FROM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}"
     "${CMAKE_CURRENT_SOURCE_DIR}/verbatim.l")
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/verbatim_lexer.cpp
         ${CMAKE_CURRENT_BINARY_DIR}/verbatim_lexer.hpp
  COMMAND ${FLEX_EXECUTABLE} ARGS "${VERBATIM_LL_FROM_BINARY_DIR}"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/verbatim.l
  COMMENT "-- NMODL : GENERATING VERBATIM LEXER WITH FLEX! --")

# Command to generate differential equation lexer. See comment above about absolute paths.
file(RELATIVE_PATH DIFFEQ_LL_FROM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}"
     "${CMAKE_CURRENT_SOURCE_DIR}/diffeq.ll")
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/diffeq_base_lexer.cpp
         ${CMAKE_CURRENT_BINARY_DIR}/diffeq_base_lexer.hpp
  COMMAND ${FLEX_EXECUTABLE} ARGS "${DIFFEQ_LL_FROM_BINARY_DIR}"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/diffeq.ll
  COMMENT "-- NMODL : GENERATING DIFFERENTIAL EQUATION LEXER WITH FLEX! --")

# Command to generate C (11) lexer. See comment above about absolute paths.
file(RELATIVE_PATH C11_LL_FROM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}"
     "${CMAKE_CURRENT_SOURCE_DIR}/c11.ll")
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/c11_base_lexer.cpp
         ${CMAKE_CURRENT_BINARY_DIR}/c11_base_lexer.hpp
  COMMAND ${FLEX_EXECUTABLE} ARGS "${C11_LL_FROM_BINARY_DIR}"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/c11.ll
  COMMENT "-- NMODL : GENERATING C(11) LEXER WITH FLEX! --")

# Command to generate Units lexer. See comment above about absolute paths.
file(RELATIVE_PATH UNIT_LL_FROM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}"
     "${CMAKE_CURRENT_SOURCE_DIR}/unit.ll")
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/unit_base_lexer.cpp
         ${CMAKE_CURRENT_BINARY_DIR}/unit_base_lexer.hpp
  COMMAND ${FLEX_EXECUTABLE} ARGS "${UNIT_LL_FROM_BINARY_DIR}"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/unit.ll
  COMMENT "-- NMODL : GENERATING UNIT LEXER WITH FLEX! --")
# =============================================================================
# Libraries & executables
# =============================================================================

add_library(lexer STATIC ${LEXER_SOURCE_FILES} ${BISON_GENERATED_SOURCE_FILES}
                         ${AST_GENERATED_SOURCES} ${UNIT_SOURCE_FILES})
set_property(TARGET lexer PROPERTY POSITION_INDEPENDENT_CODE ON)
target_link_libraries(lexer PRIVATE util)

if(NOT NMODL_AS_SUBPROJECT)
  add_executable(nmodl_lexer main_nmodl.cpp)
  add_executable(c_lexer main_c.cpp)
  add_executable(units_lexer main_units.cpp)

  target_link_libraries(nmodl_lexer CLI11::CLI11 lexer util)
  target_link_libraries(c_lexer CLI11::CLI11 lexer util)
  target_link_libraries(units_lexer CLI11::CLI11 lexer util)
endif()

# =============================================================================
# Install executable
# =============================================================================
if(NOT NMODL_AS_SUBPROJECT)
  install(
    TARGETS nmodl_lexer
    DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}bin/lexer
    CONFIGURATIONS Debug)
  install(
    TARGETS c_lexer
    DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}bin/lexer
    CONFIGURATIONS Debug)
  install(
    TARGETS units_lexer
    DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}bin/lexer
    CONFIGURATIONS Debug)
endif()

add_custom_target(parser-gen DEPENDS ${BISON_GENERATED_SOURCE_FILES}
                                     ${BISON_GENERATED_HEADER_FILES})

=== src/parser/CMakeLists.txt ===
# =============================================================================
# Parser executable
# =============================================================================

# lexer library links with all parser related files so no need to have parser as a separate library

if(NOT NMODL_AS_SUBPROJECT)
  add_executable(nmodl_parser main_nmodl.cpp)
  add_executable(c_parser main_c.cpp)
  add_executable(units_parser main_units.cpp)

  target_link_libraries(nmodl_parser CLI11::CLI11 lexer util)
  target_link_libraries(c_parser CLI11::CLI11 lexer util)
  target_link_libraries(units_parser CLI11::CLI11 util visitor lexer)
endif()

# =============================================================================
# Install executable
# =============================================================================
if(NOT NMODL_AS_SUBPROJECT)
  install(
    TARGETS nmodl_parser
    DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}bin/parser
    CONFIGURATIONS Debug)
  install(
    TARGETS c_parser
    DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}bin/parser
    CONFIGURATIONS Debug)
  install(
    TARGETS units_parser
    DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}bin/parser
    CONFIGURATIONS Debug)
endif()

=== src/solver/CMakeLists.txt ===
# =============================================================================
# Solver sources
# =============================================================================
set(NEWTON_SOLVER_SOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/newton/newton.hpp)
set(CROUT_SOLVER_SOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/crout/crout.hpp)

# =============================================================================
# Copy necessary files to build directory
# =============================================================================
# Newton
file(GLOB NMODL_NEWTON_SOLVER_HEADER_FILES "${CMAKE_CURRENT_SOURCE_DIR}/newton/*.h*")
file(COPY ${NMODL_NEWTON_SOLVER_HEADER_FILES} DESTINATION ${CMAKE_BINARY_DIR}/include/newton/)
# Crout
file(GLOB NMODL_CROUT_SOLVER_HEADER_FILES "${CMAKE_CURRENT_SOURCE_DIR}/crout/*.h*")
file(COPY ${NMODL_CROUT_SOLVER_HEADER_FILES} DESTINATION ${CMAKE_BINARY_DIR}/include/crout/)
# Eigen
file(COPY ${NMODL_PROJECT_SOURCE_DIR}/ext/eigen/Eigen DESTINATION ${CMAKE_BINARY_DIR}/include/)

# =============================================================================
# Install solver headers and eigen from include
# =============================================================================
install(DIRECTORY ${CMAKE_BINARY_DIR}/include/ DESTINATION ${NMODL_INSTALL_DIR_SUFFIX}include)

=== src/symtab/CMakeLists.txt ===
# =============================================================================
# Symbol table library
# =============================================================================
add_library(symtab STATIC symbol.cpp symbol_properties.cpp symbol_table.cpp)
set_property(TARGET symtab PROPERTY POSITION_INDEPENDENT_CODE ON)
target_link_libraries(symtab PRIVATE util)
add_dependencies(symtab lexer)

=== test/integration/CMakeLists.txt ===
# =============================================================================
# Add extra compile flags to NMODL test sources
# =============================================================================
add_compile_options(${NMODL_EXTRA_CXX_FLAGS})
add_link_options(${NMODL_EXTRA_CXX_FLAGS})

# =============================================================================
# translation of mod files
# =============================================================================
file(GLOB modfiles "${NMODL_PROJECT_SOURCE_DIR}/test/integration/mod/*.mod")
foreach(modfile ${modfiles})
  get_filename_component(modfile_name "${modfile}" NAME)
  add_test(NAME ${modfile_name} COMMAND ${CMAKE_BINARY_DIR}/bin/nmodl ${modfile})
  cpp_cc_configure_sanitizers(TEST ${modfile_name})
endforeach()

=== test/unit/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

# =============================================================================
# Add extra compile flags to NMODL test sources
# =============================================================================
add_compile_options(${NMODL_EXTRA_CXX_FLAGS})
add_link_options(${NMODL_EXTRA_CXX_FLAGS})
add_compile_options(${NMODL_TESTS_COMPILER_WARNING_SUPPRESSIONS})

include_directories(${PYBIND11_INCLUDE_DIR} ${PYTHON_INCLUDE_DIRS})
include_directories(${NMODL_PROJECT_SOURCE_DIR}/test)
include_directories(${NMODL_PROJECT_SOURCE_DIR}/src/solver)
include_directories(${NMODL_PROJECT_SOURCE_DIR}/src/utils)
include_directories(${NMODL_PROJECT_SOURCE_DIR}/ext/eigen)

# =============================================================================
# Common input data library
# =============================================================================
add_library(test_util STATIC utils/nmodl_constructs.cpp utils/test_utils.cpp)

# =============================================================================
# Common input data library
# =============================================================================
add_library(config STATIC ${PROJECT_BINARY_DIR}/src/config/config.cpp)

# =============================================================================
# Test executables
# =============================================================================
add_executable(testmodtoken modtoken/modtoken.cpp)
add_executable(testlexer lexer/tokens.cpp)
add_executable(testparser parser/parser.cpp)
add_executable(
  testvisitor
  visitor/main.cpp
  visitor/after_cvode_to_cnexp.cpp
  visitor/constant_folder.cpp
  visitor/defuse_analyze.cpp
  visitor/global_to_range.cpp
  visitor/implicit_argument.cpp
  visitor/inline.cpp
  visitor/json.cpp
  visitor/kinetic_block.cpp
  visitor/localize.cpp
  visitor/local_to_assigned.cpp
  visitor/lookup.cpp
  visitor/loop_unroll.cpp
  visitor/misc.cpp
  visitor/neuron_solve.cpp
  visitor/nmodl.cpp
  visitor/perf.cpp
  visitor/rename.cpp
  visitor/semantic_analysis.cpp
  visitor/solve_block.cpp
  visitor/steadystate.cpp
  visitor/sympy_conductance.cpp
  visitor/sympy_solver.cpp
  visitor/units.cpp
  visitor/var_usage.cpp
  visitor/verbatim.cpp
  visitor/node_index.cpp)
add_executable(testprinter printer/printer.cpp)
add_executable(testsymtab symtab/symbol_table.cpp)
add_executable(testnewton newton/newton.cpp ${NEWTON_SOLVER_SOURCE_FILES})
add_executable(testcrout crout/crout.cpp ${CROUT_SOLVER_SOURCE_FILES})
add_executable(testfast_math fast_math/fast_math.cpp ${NEWTON_SOLVER_SOURCE_FILES})
add_executable(testunitlexer units/lexer.cpp)
add_executable(testunitparser units/parser.cpp)
add_executable(testcodegen codegen/main.cpp codegen/codegen_helper.cpp codegen/codegen_utils.cpp
                           codegen/codegen_cpp_visitor.cpp codegen/transform.cpp)

target_link_libraries(testmodtoken lexer util)
target_link_libraries(testlexer lexer util)
target_link_libraries(
  testparser
  visitor
  symtab
  lexer
  util
  test_util
  printer
  ${NMODL_WRAPPER_LIBS})
target_link_libraries(
  testvisitor
  visitor
  symtab
  lexer
  util
  test_util
  printer
  ${NMODL_WRAPPER_LIBS})
target_link_libraries(
  testcodegen
  codegen
  visitor
  symtab
  lexer
  util
  test_util
  printer
  ${NMODL_WRAPPER_LIBS})
target_link_libraries(testprinter printer util)
target_link_libraries(testsymtab symtab lexer util)
target_link_libraries(testunitlexer lexer util)
target_link_libraries(testunitparser lexer test_util config)

# =============================================================================
# Use catch_discover instead of add_test for granular test result reporting.
# =============================================================================
set(test_env ${NMODL_SANITIZER_ENABLE_ENVIRONMENT})
set(testvisitor_env "PYTHONPATH=${PROJECT_BINARY_DIR}/lib:$ENV{PYTHONPATH}")
if(NOT LINK_AGAINST_PYTHON)
  list(APPEND testvisitor_env "NMODL_PYLIB=$ENV{NMODL_PYLIB}")
  list(APPEND testvisitor_env
       "NMODL_WRAPLIB=${PROJECT_BINARY_DIR}/lib/nmodl/libpywrapper${CMAKE_SHARED_LIBRARY_SUFFIX}")
endif()

foreach(
  test_name
  testcodegen
  testmodtoken
  testlexer
  testparser
  testvisitor
  testprinter
  testsymtab
  testnewton
  testcrout
  testfast_math
  testunitlexer
  testunitparser)

  target_link_libraries(${test_name} Catch2::Catch2)
  cpp_cc_configure_sanitizers(TARGET ${test_name})
  set(env ${test_env})
  list(APPEND env ${${test_name}_env})
  # See https://github.com/catchorg/Catch2/issues/2424
  string(REPLACE ";" ";ENVIRONMENT;" _environment_vars_list "${env}")
  # Catch2 doesn't set these environment variables when running the executable to discover tests
  # (https://github.com/catchorg/Catch2/issues/1810). This means that in builds that enable it, we
  # see errors from the LeakSanitizer during the build. These seem to be harmless because Catch2
  # does not seem to check the exit code.
  catch_discover_tests(${test_name} TEST_PREFIX "${test_name}/" PROPERTIES ENVIRONMENT
                       "${_environment_vars_list}")
endforeach()

# =============================================================================
# pybind11 tests
# =============================================================================
add_test(NAME Ode COMMAND ${PYTHON_EXECUTABLE} -m pytest ${NMODL_PROJECT_SOURCE_DIR}/test/unit/ode)
set_tests_properties(Ode PROPERTIES ENVIRONMENT
                                    PYTHONPATH=${PROJECT_BINARY_DIR}/lib:$ENV{PYTHONPATH})

if(NMODL_ENABLE_PYTHON_BINDINGS)
  add_test(NAME Pybind COMMAND ${PYTHON_EXECUTABLE} -m pytest
                               ${NMODL_PROJECT_SOURCE_DIR}/test/unit/pybind)
  set_tests_properties(Pybind PROPERTIES ENVIRONMENT
                                         PYTHONPATH=${PROJECT_BINARY_DIR}/lib:$ENV{PYTHONPATH})
  cpp_cc_configure_sanitizers(TEST Pybind PRELOAD)
endif()

=== debian/changelog ===
nmodl (0.5-1) unstable; urgency=medium

  * New upstream release: 0.5
  * Explicitly add some missing Python dependencies
  * Refresh find-packaged-hpc-coding-conventions.patch

 -- Matthias Klumpp <mak@debian.org>  Thu, 02 Feb 2023 22:17:15 +0100

nmodl (0.4-1) unstable; urgency=medium

  * Initial release, required by NEURON 0.8.x

 -- Matthias Klumpp <mak@debian.org>  Thu, 26 Jan 2023 22:54:02 +0100

=== debian/control ===
Source: nmodl
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>
Build-Depends: bison,
               bluebrain-hpc-coding-conventions,
               catch2,
               chrpath,
               cmake,
               debhelper-compat (= 13),
               dh-python,
               flex,
               libcli11-dev,
               libeigen3-dev,
               libfl-dev,
               libfmt-dev,
               libpython3-dev,
               libspdlog-dev,
               nlohmann-json3-dev,
               pybind11-dev,
               python3-jinja2,
               python3-pkg-resources,
               python3-pytest,
               python3-sympy,
               python3-yaml,
               python3:any
Standards-Version: 4.6.2
Rules-Requires-Root: no
X-Python3-Version: >= 3.11
Homepage: https://github.com/BlueBrain/nmodl
Vcs-Git: https://salsa.debian.org/science-team/nmodl.git
Vcs-Browser: https://salsa.debian.org/science-team/nmodl

Package: nmodl
Architecture: any
Depends: python3-nmodl (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Code generation engine for the NEURON modeling language
 The NMODL Framework is a code generation engine for the
 NEURON MODeling Language (NMODL).
 It is designed with modern compiler and code generation techniques to:
   * Provide modular tools for parsing, analysing and transforming NMODL
   * Provide easy to use, high level Python API
   * Generate optimised code for modern compute architectures
     including CPUs, GPUs
   * Flexibility to implement new simulator backends
   * Support the full NMODL specification

Package: python3-nmodl
Architecture: any
Section: python
Depends: python3-jinja2,
         python3-pkg-resources,
         python3-sympy,
         python3-yaml,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: nmodl
Description: Python support for the NEURON modeling language engine
 The NMODL Framework is a code generation engine for the
 NEURON MODeling Language (NMODL).
 .
 This package contains support for using nmodl from Python.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

BUILD_FLAGS = \
	-DCMAKE_INSTALL_RPATH="" \
	-DNMODL_3RDPARTY_USE_CATCH2:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_CLI11:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_EIGEN:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_FMT:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_JSON:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_PYBIND11:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_SPDLOG:BOOL=OFF
%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_FLAGS)

override_dh_auto_install:
	dh_auto_install

	chrpath -d $(CURDIR)/debian/tmp/usr/bin/nmodl

override_dh_auto_test:
	:
